var app = angular.module('MDrivenAngularApp');

var blue		= '#348fe2',
    blueLight	= '#5da5e8',
    blueDark	= '#1993E4',
    aqua		= '#49b6d6',
    aquaLight	= '#6dc5de',
    aquaDark	= '#3a92ab',
    green		= '#00acac',
    greenLight	= '#33bdbd',
    greenDark	= '#008a8a',
    orange		= '#f59c1a',
    orangeLight	= '#f7b048',
    orangeDark	= '#c47d15',
    dark		= '#2d353c',
    grey		= '#b6c2c9',
    purple		= '#727cb6',
    purpleLight	= '#8e96c5',
    purpleDark	= '#5b6392',
    red         = '#ff5b57';

/* -------------------------------
   32.0 CONTROLLER - Flot Chart
------------------------------- */
app.controller('chartFlotController', function($scope, $rootScope) {
    function PlotFromModel(newValue) {
        var datafrommodel = [];
if (!newValue)
  return;

for (i = 0; i < newValue.length; i++) { 
            var y = newValue[i];
            datafrommodel.push([y.XAxis,y.YAxis]);
}
   
 /* Line Chart
        ------------------------- */
        var data1 = [ 
            [1, 40], [2, 50], [3, 60], [4, 60], [5, 60], [6, 65], [7, 75], [8, 90], [9, 100], [10, 105], 
            [11, 110], [12, 110], [13, 120], [14, 130]
        ];
        var data2 = [
            [1, 10],  [2, 6], [3, 10], [4, 12], [5, 18], [6, 20], [7, 25], [8, 23], [9, 24], [10, 25], 
            [11, 18], [12, 30], [13, 25], [14, 25], [15, 30], [16, 27], [17, 20], [18, 18], [19, 31], [20, 23]
        ];
        var xLabel = [
            [1,''],[2,''],[3,'May&nbsp;15'],[4,''],[5,''],[6,'May&nbsp;19'],[7,''],[8,''],[9,'May&nbsp;22'],[10,''],
            [11,''],[12,'May&nbsp;25'],[13,''],[14,''],[15,'May&nbsp;28'],[16,''],[17,''],[18,'May&nbsp;31'],[19,''],[20,'']
        ];
        $.plot($("#interactive-chart"), [{
            data: data1, 
            label: "Page Views", 
            color: blue,
            lines: { show: true, fill:false, lineWidth: 2 },
            points: { show: true, radius: 3, fillColor: '#fff' },
            shadowSize: 0
        }, {
            data: data2,
            label: 'Visitors',
            color: green,
            lines: { show: true, fill:false, lineWidth: 2 },
            points: { show: true, radius: 3, fillColor: '#fff' },
            shadowSize: 0
        },
{
            data: datafrommodel,
            label: 'FromModel',
            color: purple,
            lines: { show: true, fill:false, lineWidth: 2 },
            points: { show: true, radius: 3, fillColor: '#fff' },
            shadowSize: 0
        }], {
            xaxis: {  ticks:xLabel, tickDecimals: 0, tickColor: '#ddd' },
            yaxis: {  ticks: 10, tickColor: '#ddd', min: 0, max: 200 },
            grid: { 
                hoverable: true, 
                clickable: true,
                tickColor: "#ddd",
                borderWidth: 1,
                backgroundColor: '#fff',
                borderColor: '#ddd'
            },
            legend: {
                labelBoxBorderColor: '#ddd',
                margin: 10,
                noColumns: 1,
                show: true
            }
        });
} //PlotFromModel

$scope.$on('ProcessingServerMessagesComplete', function(scope){
  PlotFromModel(scope.targetScope.ViewModelRoot.DiagramPoints);
 });


/*
$scope.$watchCollection('root.DiagramPoints', function(newValue, oldValue) {
  PlotFromModel(newValue);
 });
*/


   
});


