//# sourceURL=Turnkey/EXT_Scripts/tkTreeView.js
/// <reference path="../../../TypescriptCanvasWork/typings/jquery/jquery.d.ts" />
var TreeViewLogic = (function () {
    function TreeViewLogic() {
    }
    TreeViewLogic.prototype.Init = function (scope, element, document) {
        this._Scope = scope;
        this._Element = element[0];
        this._document = document[0];
        var tree = this._Element;
        if (typeof tree != 'undefined') {
            if (typeof tree.openedClass != 'undefined') {
                TreeViewLogic._openedClass = tree.openedClass;
            }
            if (typeof tree.closedClass != 'undefined') {
                TreeViewLogic._closedClass = tree.closedClass;
            }
        }
        ;
    };
    TreeViewLogic._openedClass = 'glyphicon-minus-sign';
    TreeViewLogic._closedClass = 'glyphicon-plus-sign';
    return TreeViewLogic;
}());
function InstallTheDirectiveTreeView(streamingAppController) {
    console.trace("InstallTheDirectiveTreeView" + streamingAppController.toString());
    var myTreeViewLogics = [];
    streamingAppController.directive('tkTreeView', ['$document', function ($document) {
            return {
                link: function (scope, element, attr) {
                    //debugger;
                    element.attr("vmclassid", scope.data.VMClassId.asString);
                    var treeviewLogic = new TreeViewLogic();
                    treeviewLogic.Init(scope, element, $document);
                    myTreeViewLogics.push(treeviewLogic);
                }
            };
        }]);
    streamingAppController.directive('tkData', ['$document', function ($document) {
            return {
                link: function (scope, element, attr) {
                    element.attr("vmclassid", scope.data.VMClassId.asString);
                }
            };
        }]);
    streamingAppController.directive('tkTreeNode', ['$document', function ($document) {
            return {
                link: function (scope, element, attr) {
                    if (element != null) {
                        var branch_1 = $(element); //li with children ul
                        branch_1.prepend("<i class='indicator glyphicon " + TreeViewLogic._openedClass + "'></i>");
                        branch_1.addClass('branch');
                        branch_1.on('click', function (e) {
                            var icon = branch_1.children('i:first');
                            icon.toggleClass(TreeViewLogic._openedClass + " " + TreeViewLogic._closedClass);
                            branch_1.children().children().toggle();
                            e.preventDefault();
                            scope.data.SelectRow();
                            return false;
                        });
                        branch_1.children().children().toggle();
                        //fire event from the dynamically added icon
                        branch_1.find('.branch .indicator').each(function () {
                            branch_1.on('click', function (e) {
                                branch_1.closest('li').click();
                                e.preventDefault();
                                return false;
                            });
                        });
                        //fire event to open branch if the li contains an anchor instead of text
                        branch_1.find('.branch>a').each(function (anchor) {
                            $(anchor).on('click', function (e) {
                                $(anchor).closest('li').click();
                                e.preventDefault();
                                return false;
                            });
                        });
                        //fire event to open branch if the li contains a button instead of text
                        branch_1.find('.branch>button').each(function (button) {
                            $(button).on('click', function (e) {
                                $(button).closest('li').click();
                                e.preventDefault();
                                return false;
                            });
                        });
                    }
                }
            };
        }]);
}
console.trace("tkTreeView file loaded 3");
InstallTheDirectiveTreeView(angular.module('MDrivenAngularApp'));
//# sourceMappingURL=tkTreeView.js.map