//# sourceURL=Turnkey/EXT_Scripts/tkTreeView.js
/// <reference path="../../../TypescriptCanvasWork/typings/jquery/jquery.d.ts" />








class TreeViewLogic {
  private _Scope: any;
  private _Element: HTMLDivElement;
  private _document: HTMLDocument


  Init(scope: any, element: HTMLDivElement[], document: HTMLDocument[]): void {
    this._Scope = scope;
    this._Element = element[0];
    this._document = document[0];

    let tree: any = this._Element;
    if (typeof tree != 'undefined') {
      if (typeof tree.openedClass != 'undefined') {
        TreeViewLogic._openedClass = tree.openedClass;
      }
      if (typeof tree.closedClass != 'undefined') {
        TreeViewLogic._closedClass = tree.closedClass;
      }
    };


  }

  public static _openedClass = 'glyphicon-minus-sign';
  public static _closedClass = 'glyphicon-plus-sign';

}

function InstallTheDirectiveTreeView(streamingAppController) {
  console.trace("InstallTheDirectiveTreeView" + streamingAppController.toString());
  let myTreeViewLogics: TreeViewLogic[] = [];
  streamingAppController.directive('tkTreeView', ['$document', function ($document) {
    return {
      link: function (scope, element, attr) {

        //debugger;
        element.attr("vmclassid", scope.data.VMClassId.asString);

        var treeviewLogic = new TreeViewLogic();
        treeviewLogic.Init(scope, element, $document);
        myTreeViewLogics.push(treeviewLogic);
      }
    };
  }]);

  streamingAppController.directive('tkData', ['$document', function ($document) {
    return {
      link: function (scope, element, attr) {
        element.attr("vmclassid", scope.data.VMClassId.asString);
      }
    };
  }]);

  streamingAppController.directive('tkTreeNode', ['$document', function ($document) {
    return {
      link: function (scope, element, attr) {
        if ((<HTMLLIElement>element) != null) {
          let branch = $(<HTMLLIElement>element); //li with children ul
          branch.prepend("<i class='indicator glyphicon " + TreeViewLogic._openedClass + "'></i>");
          branch.addClass('branch');
          branch.on('click', function (e) {
            var icon = branch.children('i:first');
            icon.toggleClass(TreeViewLogic._openedClass + " " + TreeViewLogic._closedClass);
            branch.children().children().toggle();
            e.preventDefault();
            scope.data.SelectRow();
            return false;
          })
          branch.children().children().toggle();

          //fire event from the dynamically added icon
          branch.find('.branch .indicator').each(function () {
            branch.on('click', function (e) {
              branch.closest('li').click();
              e.preventDefault();
              return false;
            });
          });
          //fire event to open branch if the li contains an anchor instead of text
          branch.find('.branch>a').each(function (anchor) {
            $(anchor).on('click', function (e) {
              $(anchor).closest('li').click();
              e.preventDefault();
              return false;
            });
          });
          //fire event to open branch if the li contains a button instead of text
          branch.find('.branch>button').each(function (button) {
            $(button).on('click', function (e) {
              $(button).closest('li').click();
              e.preventDefault();
              return false;
            });
          });

        }
      }
    };
  }]);


}



console.trace("tkTreeView file loaded 3");
InstallTheDirectiveTreeView(angular.module('MDrivenAngularApp'));



